
drop function if exists l3d.search_query3(varchar,varchar,boolean);

CREATE OR REPLACE FUNCTION l3d.search_query3(p_uri character varying, p_query character varying, result_as_string boolean)
 RETURNS TABLE(query_result varchar)
 LANGUAGE plpgsql
AS $function$
declare
	--- select * from l3d.search_query('/data/search/7cf9b1bf77bbf243793721ae91939d69cfc222cb', '{"query":{"select":["nodeId","metadata.auxAttributes.label"],"conditions":[{"nodeType":"aux"},{"metadata":"auxProperties.pmiType","equals":"DatumFeatureSymbol"},{"metadata":"auxAttributes.label","equals":{"select":["metadata.auxProperties.primaryReference"],"conditions":[{"nodeType":"aux"},{"metadata":"auxProperties.pmiType","equals":"FeatureControlFrame"},{"nodeId":49}]}}]},"offsets":{"structOffset":1,"auxOffset":2,"shapeInstanceOffset":3}}')
		v_fields varchar[];
		v_keys varchar[] ;
		v_operators varchar[] ;
		v_values varchar[];
		v_offsets hstore;

		v_cache_id bigint;
begin

		if result_as_string then

			return query select ('[' || coalesce( array_to_string( array_agg(r.query_result), ','), '') || ']')::varchar from l3d.search_query3(p_uri, p_query, false) r;

		else

			return query
			select ( '[' || array_to_string(r.query_result, ',') || ']' ) ::varchar as qr
			from l3d.search_query3(p_uri, p_query) r;

	 	end if;

end;
$function$;

alter function l3d.search_query3(varchar,varchar,boolean) owner to i3dhub;

drop function if exists l3d.search_query3(varchar,varchar);

CREATE OR REPLACE FUNCTION l3d.search_query3(p_uri varchar, p_query varchar)
RETURNS table(query_result varchar[])
    LANGUAGE 'plpgsql'
AS $BODY$
declare
	--- select * from l3d.search_query('/data/search/7cf9b1bf77bbf243793721ae91939d69cfc222cb', '{"query":{"select":["nodeId","metadata.auxAttributes.label"],"conditions":[{"nodeType":"aux"},{"metadata":"auxProperties.pmiType","equals":"DatumFeatureSymbol"},{"metadata":"auxAttributes.label","equals":{"select":["metadata.auxProperties.primaryReference"],"conditions":[{"nodeType":"aux"},{"metadata":"auxProperties.pmiType","equals":"FeatureControlFrame"},{"nodeId":49}]}}]},"offsets":{"structOffset":1,"auxOffset":2,"shapeInstanceOffset":3}}')
	-- select * from l3d.search_query('/data/search/7cf9b1bf77bbf243793721ae91939d69cfc222cb', '{"query":{"select":["nodeId","metadata.auxAttributes.label"],"conditions":[{"nodeType":"aux"},{"metadata":"auxProperties.pmiType","equals":"DatumFeatureSymbol"},{"metadata":"auxAttributes.label","equals":{"select":["metadata.auxProperties.primaryReference"],"conditions":[{"nodeType":"aux"},{"metadata":"auxProperties.pmiType","equals":"FeatureControlFrame"},{"nodeId":49}]}}]},"offsets":{"structOffset":1,"auxOffset":2,"shapeInstanceOffset":3}}'::text);
	-- select * from l3d.search_query('/data/search/7cf9b1bf77bbf243793721ae91939d69cfc222cb','{"query":{"select":["nodeId"],"conditions":[{"nodeType":"aux"},{"metadata":"auxProperties.pmiType","equals":"ModelView"},{"pointsTo":18}]},"offsets":{"structOffset":0,"auxOffset":0,"shapeInstanceOffset":0}}')

		v_caches_ids integer[];
		v_offsets varchar[];

		v_node_type varchar;
begin
		-- -------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- cache on the uri 7cf9b1bf77bbf243793721ae91939d69cfc222cb
		if p_uri ~ '/data/search/[a-fA-F0-9]{40}' then

			select array_agg( cac.id )::integer[]
			into v_caches_ids
			from
			(
				select
						substring(p_uri , '/data/search/([a-fA-F0-9]{40})') as uuid
			) a , l3d."cache" cac
			where
				cac.uuid          = a.uuid and
				cac.ext_cache_id0 = 0 and
				cac.ext_cache_id1 = 0 and
				cac.active ;

--			raise notice 'offsets: %',  substring (p_query , '"?offsets"?[ ]*:[ ]*{([^}]*)');

			v_offsets := array[ replace( substring (p_query , '"?offsets"?[ ]*:[ ]*{([^}]*)'), ':', '=>' )]::varchar[];


		elsif p_uri ~ '/data/search' then --cache(s) inside the query

			if p_query not ilike '%caches%:%{%}%' then
				raise exception 'caches are missing on the query %', p_query;
			end if;

			select array_agg(cac.id)::integer[] , array_agg(a.cache_offsets)
			into v_caches_ids, v_offsets
			from
			(
				select string_to_array( substring(c, '"([^"]*)"') , '/')as cache_uri,
						substring(c, '[[](.*)[]]') as cache_offsets
				from
				(
					select 	( regexp_matches (c, '"[a-fA-F0-9]{16}-[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}/[0-9]+/[0-9]+"[ ]*:[ ]*[^"]*', 'g')  )[1] as c
					from
					(
						select substring(p_query, '"?caches"?[ ]*:[ ]*[{][ ]*([^}]*)') as c
					) a
				) a
			) a , l3d."cache" cac
			where
				cac.uuid  = a.cache_uri[1] and
				cac.ext_cache_id0 = a.cache_uri[2] ::integer and
				cac.ext_cache_id1  = a.cache_uri[3] ::integer and
				cac.active ;

			raise notice 'caches %, offsets %', v_caches_ids, v_offsets;
		else
			raise exception 'error on l3d.search_query: wrong uri as argument : %', p_uri;
		end if;


		return query select * from l3d.search_query(p_query,v_caches_ids, v_offsets);
	 	-- -------------------------------------------------------------------------------------------------------------------------------------------------------------
end;
$BODY$;

alter function l3d.search_query3(varchar,varchar) owner to i3dhub;
