

CREATE OR REPLACE FUNCTION l3d.get_struct_nodes(
	c_id bigint,
	ref refcursor)
    RETURNS refcursor
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 
BEGIN
OPEN ref FOR SELECT n.ext_node_id , n.label
             FROM l3d.node as n
			 WHERE n.cache_id = c_id;
RETURN ref;
END;

$BODY$;

ALTER FUNCTION l3d.get_struct_nodes(bigint, refcursor)
    OWNER TO i3dhub;
	
	
--
-- get aux nodes and their properties
--	
CREATE OR REPLACE FUNCTION l3d.get_aux_nodes(c_id bigint, ref refcursor)
 RETURNS refcursor
 LANGUAGE plpgsql
AS $function$

 
BEGIN
OPEN ref FOR SELECT an.ext_aux_node_id , an.label, an.aux_node_type_id, ant."name",E'{'||string_agg('"'||avt."name"||'":"'||replace(coalesce(av.value_num::varchar,av.value_str),'"','\"')||'"',',')::varchar || '}' as properties
            FROM l3d.aux_value as av, l3d.aux_node as an, l3d.aux_value_name as avt, l3d.aux_node_type as ant
			WHERE av.aux_value_name_id = avt.id
			AND an.id = av.aux_node_id
			AND an.aux_node_type_id = ant.id
    		AND an.cache_id = c_id
    		group by an.id,an.ext_aux_node_id,an.label, an.aux_node_type_id, ant."name"
			ORDER BY an.id;
RETURN ref;
END;

$function$
;
