-- FUNCTION: public.ins_active_sessions(bigint, timestamp with time zone, integer)

-- DROP FUNCTION public.ins_active_sessions(bigint, timestamp with time zone, integer);

CREATE OR REPLACE FUNCTION public.ins_active_sessions(
	p_id bigint,
	p_time timestamp with time zone,
	p_value integer)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
INSERT INTO public.active_sessions(id,time,value)
 VALUES (coalesce(p_ID,nextval('public.active_sessions_id_seq'::regclass)),p_time,p_value) ; 
 END; 

$BODY$;

ALTER FUNCTION public.ins_active_sessions(bigint, timestamp with time zone, integer)
    OWNER TO i3dhub;

    
-- FUNCTION: public.ins_active_sessions_socket(bigint, timestamp with time zone, integer)

-- DROP FUNCTION public.ins_active_sessions_socket(bigint, timestamp with time zone, integer);

CREATE OR REPLACE FUNCTION public.ins_active_sessions_socket(
	p_id bigint,
	p_time timestamp with time zone,
	p_value integer)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
INSERT INTO public.active_sessions_socket(id,time,value)
 VALUES (coalesce(p_ID,nextval('public.active_sessions_id_seq'::regclass)),p_time,p_value) ; 
 END; 

$BODY$;

ALTER FUNCTION public.ins_active_sessions_socket(bigint, timestamp with time zone, integer)
    OWNER TO i3dhub;


-- FUNCTION: public.ins_active_sessions_created(bigint, integer, timestamp with time zone, timestamp with time zone)

-- DROP FUNCTION public.ins_active_sessions_created(bigint, integer, timestamp with time zone, timestamp with time zone);

CREATE OR REPLACE FUNCTION public.ins_active_sessions_created(
	p_id bigint,
	p_value integer,
	p_starttime timestamp with time zone,
	p_endtime timestamp with time zone)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
INSERT INTO public.active_sessions_created(id,value,start_time,end_time)
 VALUES (coalesce(p_ID,nextval('public.active_sessions_created_id_seq'::regclass)),p_value,p_StartTime,p_EndTime) ; 
 END; 
$BODY$;

ALTER FUNCTION public.ins_active_sessions_created(bigint, integer, timestamp with time zone, timestamp with time zone)
    OWNER TO i3dhub;


-- FUNCTION: public.ins_client_devices(bigint, json, json, json, json, timestamp with time zone, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, timestamp with time zone, json, json, json, json, json, json, json, json, json)

-- DROP FUNCTION public.ins_client_devices(bigint, json, json, json, json, timestamp with time zone, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, timestamp with time zone, json, json, json, json, json, json, json, json, json);

CREATE OR REPLACE FUNCTION public.ins_client_devices(
	p_id bigint,
	p_useragent json,
	p_vendor json,
	p_unmaskedvendor json,
	p_unmaskedrenderer json,
	p_starttime timestamp with time zone,
	p_supportextensions json,
	p_stencilbits json,
	p_screen json,
	p_renderer json,
	p_redbits json,
	p_platform json,
	p_maxviewportdimensions json,
	p_maxvertexuniformvectors json,
	p_maxvertextextureimageunits json,
	p_maxvertexattributes json,
	p_maxvaryingvectors json,
	p_maxtexturesize json,
	p_maxtextureimageunits json,
	p_maxrenderbuffersize json,
	p_maxfragmentuniformvectors json,
	p_maxcubemaptexturesize json,
	p_maxcombinedtextureimageunits json,
	p_maxcolorbuffers json,
	p_maxanisotropy json,
	p_greenbits json,
	p_glslversion json,
	p_glversion json,
	p_endtime timestamp with time zone,
	p_depthbits json,
	p_contextname json,
	p_contextattributes json,
	p_bluebits json,
	p_anglebackend json,
	p_angle json,
	p_alphabits json,
	p_aliasedpointsizerange json,
	p_aliasedlinewidthrange json)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
INSERT INTO public.client_devices(id,user_agent,vendor,unmasked_vendor,unmasked_renderer,start_time,support_extensions,stencil_bits,screen,renderer,red_bits,platform,max_view_port_dimensions,max_vertex_uniform_vectors,max_vertex_texture_image_units,max_vertex_attributes,max_varying_vectors,max_texture_size,max_texture_image_units,max_render_buffer_size,max_fragment_uniform_vectors,max_cube_map_texture_size,max_combined_texture_image_units,max_color_buffers,max_anisotropy,green_bits,glsl_version,gl_version,end_time,depth_bits,context_name,context_attributes,blue_bits,angle_backend,angle,alpha_bits,aliased_point_size_range,aliased_line_width_range)
 VALUES (coalesce(p_ID,nextval('public.client_devices_id_seq'::regclass)),p_UserAgent,p_Vendor,p_UnmaskedVendor,p_UnmaskedRenderer,p_StartTime,p_SupportExtensions,p_StencilBits,p_Screen,p_Renderer,p_RedBits,p_Platform,p_MaxViewportDimensions,p_MaxVertexUniformVectors,p_MaxVertexTextureImageUnits,p_MaxVertexAttributes,p_MaxVaryingVectors,p_MaxTextureSize,p_MaxTextureImageUnits,p_MaxRenderBufferSize,p_MaxFragmentUniformVectors,p_MaxCubeMapTextureSize,p_MaxCombinedTextureImageUnits,p_maxColorBuffers,p_MaxAnisotropy,p_GreenBits,p_GlslVersion,p_GlVersion,p_EndTime,p_DepthBits,p_ContextName,p_ContextAttributes,p_BlueBits,p_AngleBackend,p_Angle,p_AlphaBits,p_AliasedPointSizeRange,p_AliasedLineWidthRange) ; 
 END; 

$BODY$;

ALTER FUNCTION public.ins_client_devices(bigint, json, json, json, json, timestamp with time zone, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, json, timestamp with time zone, json, json, json, json, json, json, json, json, json)
    OWNER TO i3dhub;



-- FUNCTION: public.ins_job_status(bigint, timestamp with time zone, integer, integer, integer)

-- DROP FUNCTION public.ins_job_status(bigint, timestamp with time zone, integer, integer, integer);

CREATE OR REPLACE FUNCTION public.ins_job_status(
	p_id bigint,
	p_time timestamp with time zone,
	p_open integer,
	p_closed integer,
	p_error integer)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
INSERT INTO public.job_status(id,time,open,closed,error)
 VALUES (coalesce(p_ID,nextval('public.job_status_id_seq'::regclass)),p_Time,p_Open,p_Closed,p_Error) ; 
 END; 

$BODY$;

ALTER FUNCTION public.ins_job_status(bigint, timestamp with time zone, integer, integer, integer)
    OWNER TO i3dhub;



-- FUNCTION: public.ins_feedback(bigint, integer, character varying, timestamp with time zone)

-- DROP FUNCTION public.ins_feedback(bigint, integer, character varying, timestamp with time zone);

CREATE OR REPLACE FUNCTION public.ins_feedback(
	p_id bigint,
	p_rating integer,
	p_message character varying,
	p_time timestamp with time zone)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
INSERT INTO public.feedback(id,rating,message,time)
 VALUES (coalesce(p_ID,nextval('public.feedback_id_seq'::regclass)),p_rating,p_message,p_time) ; 
 END; 

$BODY$;

ALTER FUNCTION public.ins_feedback(bigint, integer, character varying, timestamp with time zone)
    OWNER TO i3dhub;




-- FUNCTION: public.ins_client_log(bigint, character varying, timestamp with time zone)

-- DROP FUNCTION public.ins_client_log(bigint, character varying, timestamp with time zone);

CREATE OR REPLACE FUNCTION public.ins_client_log(
	p_id bigint,
	p_message character varying,
	p_time timestamp with time zone)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
INSERT INTO public.client_log(id,message,time)
 VALUES (coalesce(p_ID,nextval('public.client_log_id_seq'::regclass)),p_message,p_time) ; 
 END; 

$BODY$;

ALTER FUNCTION public.ins_client_log(bigint, character varying, timestamp with time zone)
    OWNER TO i3dhub;





-- funciton: get_active_sessions_monthly
-- get monthly active seesions

CREATE OR REPLACE FUNCTION public.get_active_sessions_monthly(
	ocursor refcursor)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	-- monthly data	
	SELECT  t.mon as key, sum(t.value) as value FROM (
		SELECT to_char(time,'Mon YYYY') as mon, extract(year from time) as year, extract(month from time) as month, value
		FROM public.active_sessions ORDER BY time 
	)t GROUP BY t.mon, t.year,t.month
	ORDER BY to_timestamp(t.mon,'Mon YYYY')
	;

 END; 

$BODY$;

ALTER FUNCTION public.get_active_sessions_monthly(refcursor)
    OWNER TO i3dhub;



-- funciton: get_active_sessions_annual
-- get annually active seesions

CREATE OR REPLACE FUNCTION public.get_active_sessions_annual(
	ocursor refcursor)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	SELECT DISTINCT t.year::varchar as key, sum(t.value) as value FROM (
		SELECT extract(year from time) as year, value
		FROM public.active_sessions
	)t GROUP BY t.year;

 END; 

$BODY$;

ALTER FUNCTION public.get_active_sessions_annual(refcursor)
    OWNER TO i3dhub;
	
	
-- funciton: get_active_sessions_daily
-- get daily active seesions

CREATE OR REPLACE FUNCTION public.get_active_sessions_daily(
	ocursor refcursor)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	SELECT  t.d as key,  sum(t.value) as value FROM (
		SELECT to_char(time,'DD Mon YYYY') as d, extract(day from time) as day, value
		FROM public.active_sessions ORDER BY time
	)t GROUP BY t.d
	ORDER BY to_timestamp(t.d,'DD Mon YYYY')
	;	

 END; 

$BODY$;

ALTER FUNCTION public.get_active_sessions_daily(refcursor)
    OWNER TO i3dhub;
	
	

-- FUNCTION: public.round_minutes(timestamp with time zone, integer)

-- DROP FUNCTION public.round_minutes(timestamp with time zone, integer);

CREATE OR REPLACE FUNCTION public.round_minutes(
	timestamp with time zone,
	integer)
    RETURNS timestamp with time zone
    LANGUAGE 'sql'

    COST 100
    IMMUTABLE 
AS $BODY$
 
  SELECT 
     date_trunc('hour', $1) 
     +  cast(($2::varchar||' min') as interval) 
     * round( 
     (date_part('minute',$1)::float + date_part('second',$1)/ 60.)::float 
     / $2::float
      )

$BODY$;

ALTER FUNCTION public.round_minutes(timestamp with time zone, integer)
    OWNER TO i3dhub;


-- FUNCTION: public.get_active_sessions(timestamp with time zone, timestamp with time zone, refcursor)

-- DROP FUNCTION public.get_active_sessions(timestamp with time zone, timestamp with time zone, refcursor);


CREATE OR REPLACE FUNCTION public.get_active_sessions(
	p_stime timestamp with time zone,
	p_etime timestamp with time zone,
	accuracy integer,
	ocursor refcursor)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$


 BEGIN 
  
   OPEN oCursor FOR 
   SELECT (EXTRACT (EPOCH FROM  public.round_minutes(time, accuracy)))*1000 as key, max(value) as value
	FROM public.active_sessions
	WHERE time >= p_stime 
	AND time <= p_etime
	GROUP BY key
	ORDER BY key
	
	;

 END; 

$BODY$;

ALTER FUNCTION public.get_active_sessions(timestamp with time zone, timestamp with time zone, integer, refcursor)
    OWNER TO i3dhub;




CREATE OR REPLACE FUNCTION public.get_feature_usage_stats(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

BEGIN 

   OPEN oCursor FOR (
   		SELECT  EXTRACT (EPOCH FROM date_trunc('day',esd.start_time)) as "Time", bit_or(fps.used_features) as "Features", sum(fps.l3d_count) as "L3DCount", sum(fps.data_size) as "DataSize"
		FROM public.expired_sessions_durations as esd , public.features_per_session as fps
		WHERE fps.expired_sessions_durations_id = esd.id
		GROUP BY start_time
	
		UNION (
			SELECT EXTRACT (EPOCH FROM date_trunc('day',fws.time)) as "Time", bit_or(fws.used_features) as "Faatures", NULL,NULL
			FROM public.features_without_session as fws
			GROUP BY time
		));
END; 

$BODY$;

ALTER FUNCTION public.get_feature_usage_stats(refcursor)
    OWNER TO i3dhub;
	
	
-- FUNCTION: public.get_feature_usage_stats_full(refcursor)

-- DROP FUNCTION public.get_feature_usage_stats_full(refcursor);	
CREATE OR REPLACE FUNCTION public.get_feature_usage_stats_full(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR (
   	SELECT  EXTRACT (EPOCH FROM esd.start_time) as "Time", fps.used_features as "Features", fps.l3d_count as "L3DCount", fps.data_size as "DataSize"
	FROM public.expired_sessions_durations as esd , public.features_per_session as fps
	WHERE fps.expired_sessions_durations_id = esd.id
	
	UNION (
		SELECT EXTRACT (EPOCH FROM fws.time) as "Time", fws.used_features as "Faatures", NULL,NULL
		FROM public.features_without_session as fws
		
	));

 END; 

$BODY$;

ALTER FUNCTION public.get_feature_usage_stats_full(refcursor)
    OWNER TO i3dhub;	
	

-- FUNCTION: public.get_client_devices_useragents(refcursor)

-- DROP FUNCTION public.get_client_devices_useragents(refcursor);

CREATE OR REPLACE FUNCTION public.get_client_devices_useragents(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	SELECT  (EXTRACT (EPOCH FROM start_time))*1000 as key, user_agent::text as value
	FROM public.client_devices
	WHERE user_agent::text != '{}'::text;

 END; 

$BODY$;

ALTER FUNCTION public.get_client_devices_useragents(refcursor)
    OWNER TO i3dhub;


-- FUNCTION: public.get_client_devices_platforms(refcursor)

-- DROP FUNCTION public.get_client_devices_platforms(refcursor);

CREATE OR REPLACE FUNCTION public.get_client_devices_platforms(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	SELECT  (EXTRACT (EPOCH FROM start_time))*1000 as key, platform::text as value
	FROM public.client_devices
	WHERE platform::text != '{}'::text;

 END; 

$BODY$;

ALTER FUNCTION public.get_client_devices_platforms(refcursor)
    OWNER TO i3dhub;


-- FUNCTION: public.get_client_devices_maxrenderbuffersizes(refcursor)

-- DROP FUNCTION public.get_client_devices_maxrenderbuffersizes(refcursor);

CREATE OR REPLACE FUNCTION public.get_client_devices_maxrenderbuffersizes(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	SELECT  (EXTRACT (EPOCH FROM start_time))*1000 as key, max_render_buffer_size::text as value
	FROM public.client_devices
	WHERE max_render_buffer_size::text != '{}'::text;

 END; 

$BODY$;

ALTER FUNCTION public.get_client_devices_maxrenderbuffersizes(refcursor)
    OWNER TO i3dhub;

-- FUNCTION: public.get_client_devices_gpuvendors(refcursor)

-- DROP FUNCTION public.get_client_devices_gpuvendors(refcursor);

CREATE OR REPLACE FUNCTION public.get_client_devices_gpuvendors(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	SELECT  (EXTRACT (EPOCH FROM start_time))*1000 as key, unmasked_vendor::text as value
	FROM public.client_devices
	WHERE unmasked_vendor::text != '{}'::text;

 END; 

$BODY$;

ALTER FUNCTION public.get_client_devices_gpuvendors(refcursor)
    OWNER TO i3dhub;


-- FUNCTION: public.get_client_devices_gpurenderers(refcursor)

-- DROP FUNCTION public.get_client_devices_gpurenderers(refcursor);

CREATE OR REPLACE FUNCTION public.get_client_devices_gpurenderers(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	SELECT  (EXTRACT (EPOCH FROM start_time))*1000 as key, unmasked_renderer::text as value
	FROM public.client_devices
	WHERE unmasked_renderer::text != '{}'::text;

 END; 

$BODY$;

ALTER FUNCTION public.get_client_devices_gpurenderers(refcursor)
    OWNER TO i3dhub;


-- FUNCTION: public.get_client_devices_glversions(refcursor)

-- DROP FUNCTION public.get_client_devices_glversions(refcursor);

CREATE OR REPLACE FUNCTION public.get_client_devices_glversions(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	SELECT  (EXTRACT (EPOCH FROM start_time))*1000 as key, gl_version::text as value
	FROM public.client_devices
	WHERE gl_version::text != '{}'::text;

 END; 

$BODY$;

ALTER FUNCTION public.get_client_devices_glversions(refcursor)
    OWNER TO i3dhub;


-- FUNCTION: public.get_client_devices_browservendors(refcursor)

-- DROP FUNCTION public.get_client_devices_browservendors(refcursor);

CREATE OR REPLACE FUNCTION public.get_client_devices_browservendors(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 	
	SELECT  (EXTRACT (EPOCH FROM start_time))*1000 as key, unmasked_vendor::text as value
	FROM public.client_devices
	WHERE unmasked_vendor::text != '{}'::text;

 END; 

$BODY$;

ALTER FUNCTION public.get_client_devices_browservendors(refcursor)
    OWNER TO i3dhub;

-- FUNCTION: public.get_client_devices_browserrenderers(refcursor)

-- DROP FUNCTION public.get_client_devices_browserrenderers(refcursor);

CREATE OR REPLACE FUNCTION public.get_client_devices_browserrenderers(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
	OPEN oCursor FOR 	
		SELECT  (EXTRACT (EPOCH FROM start_time))*1000 as key, unmasked_renderer::text as value
		FROM public.client_devices
		WHERE unmasked_renderer::text != '{}'::text;

 END; 

$BODY$;

ALTER FUNCTION public.get_client_devices_browserrenderers(refcursor)
    OWNER TO i3dhub;


-- FUNCTION: public.ins_features_usage_per_session(bigint, timestamp with time zone, timestamp with time zone, bigint[], integer[], bigint[])

-- DROP FUNCTION public.ins_features_usage_per_session(bigint, timestamp with time zone, timestamp with time zone, bigint[], integer[], bigint[])

CREATE OR REPLACE FUNCTION public.ins_features_usage_per_session(
	p_id bigint,
	p_starttime timestamp with time zone,
	p_endtime timestamp with time zone,
	p_used_features bigint[],
	p_l3d_count integer[],
	p_data_size bigint[])
    RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

DECLARE
	sessions_id integer;	
BEGIN 
	INSERT INTO public.expired_sessions_durations(id,start_time,end_time)
 	VALUES (coalesce(p_ID,nextval('public.expired_sessions_durations_id_seq'::regclass)),p_StartTime,p_EndTime) RETURNING id INTO sessions_id; 
 	
	INSERT INTO public.features_per_session(used_features,l3d_count,data_size,expired_sessions_durations_id)
	SELECT UNNEST(p_used_features), UNNEST(p_l3d_count), UNNEST(p_data_size), sessions_id;
END; 

$BODY$;

ALTER FUNCTION public.ins_features_usage_per_session(bigint, timestamp with time zone, timestamp with time zone, bigint[], integer[], bigint[])
    OWNER TO i3dhub;

    
    
-- FUNCTION: public.ins_features_usage_per_session_socket(bigint, timestamp with time zone, timestamp with time zone, bigint[], integer[], bigint[])

-- DROP FUNCTION public.ins_features_usage_per_session_socket(bigint, timestamp with time zone, timestamp with time zone, bigint[], integer[], bigint[])

CREATE OR REPLACE FUNCTION public.ins_features_usage_per_session_socket(
	p_id bigint,
	p_starttime timestamp with time zone,
	p_endtime timestamp with time zone,
	p_used_features bigint[],
	p_l3d_count integer[],
	p_data_size bigint[])
    RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

DECLARE
	sessions_id integer;	
BEGIN 
	INSERT INTO public.expired_sessions_durations_socket(id,start_time,end_time)
 	VALUES (coalesce(p_ID,nextval('public.expired_sessions_durations_socket_id_seq'::regclass)),p_StartTime,p_EndTime) RETURNING id INTO sessions_id; 
 	
	INSERT INTO public.features_per_session_socket(used_features,l3d_count,data_size,expired_sessions_durations_socket_id)
	SELECT UNNEST(p_used_features), UNNEST(p_l3d_count), UNNEST(p_data_size), sessions_id;
END; 

$BODY$;

ALTER FUNCTION public.ins_features_usage_per_session_socket(bigint, timestamp with time zone, timestamp with time zone, bigint[], integer[], bigint[])
    OWNER TO i3dhub;
    

    
    
-- FUNCTION: public.ins_features_without_session(bigint, timestamp with time zone, bigint)

-- DROP FUNCTION public.ins_features_without_session(bigint, timestamp with time zone, bigint)
CREATE OR REPLACE FUNCTION public.ins_features_without_session(
	p_id bigint,
	p_time timestamp with time zone,
	p_used_features bigint
	)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

DECLARE
	sessions_id integer;	
BEGIN 
	
	INSERT INTO public.features_without_session(id,time,used_features)
	VALUES (coalesce(p_ID,nextval('public.features_without_session_id_seq'::regclass)),p_time,p_used_features);
END; 

$BODY$;

ALTER FUNCTION public.ins_features_without_session(bigint, timestamp with time zone, bigint)
    OWNER TO i3dhub;




-- FUNCTION: public.copy_index_stats(character varying,character varying)

-- DROP FUNCTION public.copy_index_stats(character varying,character varying);

CREATE OR REPLACE FUNCTION public.copy_index_stats(
	p_conn character varying,
	p_uuid character varying)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
INSERT INTO public.index_stats_history(start_time, end_time, num_reads, queued_date,url, bytes)
	SELECT * FROM public.dblink(p_conn, $$
											SELECT processing_start_date, processing_end_date,num_reads,queued_date,insrc.url,bytes
											FROM l3d.index_source as insrc, l3d.index_stats as indstts, l3d.index_cache as inc,l3d.cache as c
											WHERE c.id = insrc.cache_id
											AND c.id = indstts.cache_id
											AND c.id= inc.cache_id
											AND c.uuid = '$$ || p_uuid ||$$'
								AND c.active=true;

						$$) as tl( processing_start_date timestamp,
								processing_end_date timestamp,
								num_reads integer,  queued_date timestamp, url character varying,bytes integer ) ;
 END; 

$BODY$;

ALTER FUNCTION public.copy_index_stats(character varying,character varying)
    OWNER TO i3dhub;




CREATE OR REPLACE FUNCTION public.reduce_stats(p_etime timestamp with time zone)
 RETURNS void
 LANGUAGE plpgsql
AS $function$
 declare
	expired_sessions_ids bigint[];
	expired_session_id bigint;
	features_without_sessions_ids bigint[];
	rec record;
 BEGIN 
	 
	 
	-- active_sessiosns table
	-- insert new row with max value of all the old records
	INSERT INTO public.active_sessions (time,value)
	SELECT p_etime as t,max(value)
	FROM public.active_sessions
	WHERE time <=p_etime
	GROUP BY t;
	
	-- delete the old records
	DELETE FROM public.active_sessions
	WHERE time < p_etime;

	-- features_per_session table
	-- collect ids of records that need to be deleted
	SELECT array_agg(id) into expired_sessions_ids
	FROM public.expired_sessions_durations
	WHERE end_time <= p_etime;
	
	--loop over the results and insert new records
	FOR rec IN (SELECT date_trunc('day',esd.end_time) as time, bit_or(fps.used_features::bit(64))::bigint as uf, sum(fps.l3d_count) as lc,sum(fps.data_size) as ds
	FROM public.expired_sessions_durations as esd , public.features_per_session as fps
	WHERE fps.expired_sessions_durations_id = esd.id
	AND esd.end_time <= p_etime
	GROUP BY time) loop
	INSERT INTO public.expired_sessions_durations(start_time,end_time)
	VALUES (rec.time ,rec.time) returning id into expired_session_id;
	INSERT INTO public.features_per_session(expired_sessions_durations_id, used_features,l3d_count, data_size)
	VALUES (expired_session_id,rec.uf,rec.lc,rec.ds);
	END LOOP;
 
  
	 --delete old records
	DELETE FROM public.features_per_session WHERE expired_sessions_durations_id = ANY(expired_sessions_ids);
	DELETE FROM  public.expired_sessions_durations WHERE id = ANY( expired_sessions_ids);
	 
	-- features_without_session
  	SELECT array_agg() INTO features_Without_sessions_ids 
  	FROM public.features_without_session as fws 
  	WHERE fws."time" <= p_etime;
 
    INSERT INTO public.features_without_session(time,used_features)
 	SELECT date_trunc('day',fws."time") AS time, bit_or(used_features::bit(64))::bigint
 	FROM public.features_without_session AS fws
 	WHERE fws."time"<= p_etime
 	GROUP BY time;
  
  	
 	DELETE FROM public.features_without_session WHERE id = ANY(features_Without_sessions_ids);
  
 	-- active_sessions_created table
 	INSERT INTO public.active_sessions_created(value,start_time,end_time)
 	SELECT sum(value), date_trunc('day',end_time) , date_trunc('day',end_time)
 	FROM public.active_sessions_created
 	WHERE end_time <= p_etime;
 
 	DELETE FROM public.active_sessions_created 
 	WHERE end_time < p_etime;
 
 
 END; 

$function$;




--
-- get reviews function
--
CREATE OR REPLACE FUNCTION public.get_reviews(
	ocursor refcursor)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE 
AS $BODY$

 BEGIN 
  
   OPEN oCursor FOR 
  	SELECT time,message,rating
	FROM public.feedback;
	

 END; 

$BODY$;

ALTER FUNCTION public.get_reviews(refcursor)
    OWNER TO i3dhub;
